/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : IO1.c
**     Project     : MC56F84000_PWM_ADC
**     Processor   : MC56F84789VLL
**     Component   : Init_GPIO
**     Version     : Component 01.093, Driver 01.17, CPU db: 3.50.001
**     Compiler    : CodeWarrior DSP C Compiler
**     Date/Time   : 2019-04-03, 15:22, # CodeGen: 52
**     Abstract    :
**                  This "Init_GPIO" Peripheral Inspector implements the
**                  General Purpose Input/Output (GPIO), basic initialization
**                  and settings.
**     Settings    :
**          Component name                                 : IO1
**          Device                                         : GPIOB
**          Device signal                                  : 
**          Port control                                   : Individual pins
**          Pins                                           : 2
**            Pin                                          : 3
**              Pin                                        : GPIOB3/ANB3/VREFLB/CMPC_IN0
**              Pin signal                                 : 
**              Direction                                  : Output
**              Output value                               : 0
**              Pull resistor                              : pull up
**              Open drain                                 : push-pull
**              Interrupt                                  : Disabled
**              Interrupt polarity                         : High
**            Pin                                          : 8
**              Pin                                        : GPIOB8/ANC20/VREFLC
**              Pin signal                                 : 
**              Direction                                  : Output
**              Output value                               : 0
**              Pull resistor                              : no pull resistor
**              Open drain                                 : push-pull
**              Interrupt                                  : Disabled
**              Interrupt polarity                         : High
**          Interrupt                                      : 
**            Interrupt                                    : INT_GPIOB
**            Priority                                     : default
**            ISR name                                     : 
**          Initialization                                 : 
**            Call Init method                             : yes
**            Enable peripheral clock                      : yes
**     Contents    :
**         Init - void IO1_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file IO1.c
** @version 01.17
** @brief
**                  This "Init_GPIO" Peripheral Inspector implements the
**                  General Purpose Input/Output (GPIO), basic initialization
**                  and settings.
*/         
/*!
**  @addtogroup IO1_module IO1 module documentation
**  @{
*/         

/* MODULE IO1. */

#include "IO1.h"

/*
** ===================================================================
**     Method      :  IO1_Init (component Init_GPIO)
**     Description :
**         This method initializes registers of the GPIO module
**         according to this Peripheral Initialization Bean settings. 
**         Call this method in the user code to initialize the module.
**         By default, the initialization is made in initialization
**         code; see "Call Init method" property of the bean for more
**         details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void IO1_Init(void)
{
  /* GPIOB_PUS: PUS8=1,PUS3=1 */
  clrSetReg16Bits(GPIOB_PUS, 0x00U, 0x0108U); 
  /* GPIOB_PUR: PU8=0,PU3=1 */
  clrSetReg16Bits(GPIOB_PUR, 0x0100U, 0x08U); 
  /* GPIOB_PPMODE: PPMODE8=1,PPMODE3=1 */
  clrSetReg16Bits(GPIOB_PPMODE, 0x00U, 0x0108U); 
  /* GPIOB_DR: D8=0,D3=0 */
  clrSetReg16Bits(GPIOB_DR, 0x0108U, 0x00U); 
  /* GPIOB_DDR: DD8=1,DD3=1 */
  clrSetReg16Bits(GPIOB_DDR, 0x00U, 0x0108U); 
  /* GPIOB_IPOLR: IPOL8=0,IPOL3=0 */
  clrSetReg16Bits(GPIOB_IPOLR, 0x0108U, 0x00U); 
  /* GPIOB_IENR: IEN8=0,IEN3=0 */
  clrSetReg16Bits(GPIOB_IENR, 0x0108U, 0x00U); 
}

/* END IO1. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
