/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DAC.h
**     Project     : MC65F84000_PWM_DAC_HSCMP
**     Processor   : MC56F84789VLL
**     Component   : Init_DAC
**     Version     : Component 01.019, Driver 01.07, CPU db: 3.50.001
**     Compiler    : CodeWarrior DSP C Compiler
**     Date/Time   : 2015-04-30, 14:15, # CodeGen: 1
**     Abstract    :
**         This bean encapsulates 12-bit Digital to Analog Converter (DAC) interface.
**         DAC features include: 12-bit resolution, 2 microsecond conversion rate,
**         power down mode, output can be routed to internal comparator or off chip
**         DAC can drive 3K ohm, 400pF load, choice of asynchronous or synchronous
**         updates, sync input can be connected to on chip peripherals(PITs, TMRs,
**         PWM reload flag, or GPIO inputs), automatic mode allows the DAC to
**         generate its own output waveforms including square, triangle, and sawtooth
**         waveforms, automatic mode allows programmable period, update rate, and range.
**     Settings    :
**          Component name                                 : DAC
**          Device                                         : DAC
**          Settings                                       : 
**            Glitch filter                                : Enabled
**            Glitch filter count bits                     : 24
**            Up counting                                  : Disabled
**            Down counting                                : Disabled
**            Automatic mode                               : Disabled
**            Data word justification                      : Right
**            High speed/low speed                         : High speed
**            DMA enable                                   : Disabled
**            Watermark level                              : 2 samples
**          Pins                                           : 
**            Output pin                                   : Enabled
**              Analog output pin                          : GPIOC5/DACO/XB_IN7
**              Analog output pin signal                   : 
**            Synchronous mode                             : Disabled
**          Initialization                                 : 
**            Call Init method                             : yes
**            Power down                                   : no
**            Enable peripheral clock                      : yes
**            DAC data register value                      : 7FF
**            DAC minimum register value                   : 0
**            DAC maximum register value                   : 4095
**            DAC step size register value                 : 0
**     Contents    :
**         Init - void DAC_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file DAC.h
** @version 01.07
** @brief
**         This bean encapsulates 12-bit Digital to Analog Converter (DAC) interface.
**         DAC features include: 12-bit resolution, 2 microsecond conversion rate,
**         power down mode, output can be routed to internal comparator or off chip
**         DAC can drive 3K ohm, 400pF load, choice of asynchronous or synchronous
**         updates, sync input can be connected to on chip peripherals(PITs, TMRs,
**         PWM reload flag, or GPIO inputs), automatic mode allows the DAC to
**         generate its own output waveforms including square, triangle, and sawtooth
**         waveforms, automatic mode allows programmable period, update rate, and range.
*/         
/*!
**  @addtogroup DAC_module DAC module documentation
**  @{
*/         

#ifndef __DAC
#define __DAC

/* MODULE DAC. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */

#include "Cpu.h"




/* PESL device mapping  */
#define DAC_DEVICE DAC

void DAC_Init(void);
/*
** ===================================================================
**     Method      :  DAC_Init (component Init_DAC)
**     Description :
**         This method initializes registers of the DAC module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see <Call Init method> property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END DAC. */

#endif
/* ifndef __DAC */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
